rules:
  - id: okay-form-checkbox-view-component-haml
    pattern-either:
      - pattern-regex: Pajamas::CheckboxComponent
      - pattern-regex: gitlab_ui_checkbox_component
    message: Correct usage of Pajamas::CheckboxComponent component.
    languages:
      - generic
    severity: INFO
    paths:
      include:
        - '*.haml'
    metadata:
      componentLabel: 'component:form-checkbox'
      pajamasCompliant: true

  - id: form-checkbox-class-haml
    patterns:
      - pattern: gl-form-checkbox
    message: |
      Detected usage of `gl-form-checkbox` class inside HAML file.
    languages:
      - generic
    severity: ERROR
    paths:
      include:
        - '*.haml'
      exclude:
        - 'app/components/pajamas/checkbox_component.html.haml'
    metadata:
      componentLabel: 'component:form-checkbox'
      pajamasCompliant: false
      epic: 'https://gitlab.com/groups/gitlab-org/-/epics/7972'

  - id: form-checkbox-custom-implementation-haml
    patterns:
      - pattern-regex: check_box(?:_tag)?\b
    message: |
      Detected usage of custom checkbox implementation inside HAML file.
    languages:
      - generic
    severity: ERROR
    paths:
      include:
        - '*.haml'
      exclude:
        - 'app/components/pajamas/checkbox_component.html.haml'
    metadata:
      componentLabel: 'component:form-checkbox'
      pajamasCompliant: false
      epic: 'https://gitlab.com/groups/gitlab-org/-/epics/7972'

  - id: form-checkbox-native-haml
    pattern-either:
      - pattern-regex: '[^[]type: "checkbox"'
      - pattern-regex: "[^[]type: 'checkbox'"
    message: |
      Detected usage of native checkbox usage inside HAML file.
      Please, consider using the Pajamas::CheckboxComponent ViewComponent instead.
    languages:
      - generic
    severity: ERROR
    paths:
      include:
        - '*.haml'
      exclude:
        - 'app/components/pajamas/checkbox_component.html.haml'
    metadata:
      componentLabel: 'component:form-checkbox'
      pajamasCompliant: false
      epic: 'https://gitlab.com/groups/gitlab-org/-/epics/7972'
